from .unit import Unit
from .points import Point
import uuid

# Costanti
AGE_THRESHOLD = 200


class Bomb(Unit):
    def __init__(self, game, position=(0,0), id=None):
        super().__init__(position)
        self.id = id if id else uuid.uuid4()
        self.game = game
        self.position = position
        self.bbox = (0, 0, 0, 0)
        self.stop = 0
        self.age = 0
        self.speed = 4
        self.partial_move = 0
        self.position_before = position
        self.fight = False

    def move(self):
        pass
        
    def collisions(self):
        pass
                    
    def die(self, unit=None):
        if not unit:
            unit = self
        self.game.units.pop(unit.id)
        
        
    def draw(self):
        n = self.age // 40
        n= 3 -n +1
        if n < 0:
            n = 0
        image = self.game.bomb_assets[n]
        image_size = self.game.engine.get_image_size(image)
        self.rat_image = image
        partial_x, partial_y = 0, 0
        
        x_pos = self.position_before[0] * self.game.cell_size + (self.game.cell_size - image_size[0]) // 2 + partial_x
        y_pos = self.position_before[1] * self.game.cell_size + (self.game.cell_size - image_size[1]) // 2 + partial_y
        
        self.game.engine.draw_image(x_pos, y_pos, image, anchor="nw", tag="unit")

class Timer(Bomb):
    def move(self):
        self.age += self.speed
        if self.age == AGE_THRESHOLD:
            self.die()
            
    def die(self, unit=None, score=None):
        score = 10
        print("BOOM")
        if not unit:
            unit = self
        self.game.play_sound("BOMB.WAV")
        try:
            self.game.units.pop(unit.id)
        except:
            print(f"Unit {unit.id} already dead")
        self.game.spawn_unit(Explosion, unit.position)
        for direction in ["N", "S", "E", "W"]:
            x, y = unit.position
            while True:
                if not self.game.map.is_wall(x, y):
                    self.game.spawn_unit(Explosion, (x, y))
                    for victim in self.game.unit_positions.get((x, y), []):
                        if victim.id in self.game.units:
                            if victim.partial_move >= 0.5:
                               victim.die(score=score)
                               if score < 160:
                                   score *= 2                              
                    for victim in self.game.unit_positions_before.get((x, y), []):
                        if victim.id in self.game.units:
                            if victim.partial_move < 0.5:
                                victim.die(score=score)
                                if score < 160:
                                    score *= 2
                else:
                    break
                if direction == "N":
                    y -= 1
                elif direction == "S":
                    y += 1
                elif direction == "E":
                    x += 1
                elif direction == "W":
                    x -= 1
            
        
class Explosion(Bomb):
    def move(self):
        self.age += self.speed*5
        if self.age == AGE_THRESHOLD:
            self.die()
            
    def draw(self):
        image = self.game.assets["BMP_EXPLOSION"]
        image_size = self.game.engine.get_image_size(image)
        partial_x, partial_y = 0, 0
        
        x_pos = self.position_before[0] * self.game.cell_size + (self.game.cell_size - image_size[0]) // 2 + partial_x
        y_pos = self.position_before[1] * self.game.cell_size + (self.game.cell_size - image_size[1]) // 2 + partial_y
        
        self.game.engine.draw_image(x_pos, y_pos, image, anchor="nw", tag="unit")